Chinaunix首页 | 论坛 | 博客
  • 博客访问: 2533673
  • 博文数量: 401
  • 博客积分: 12926
  • 博客等级: 上将
  • 技术积分: 4578
  • 用 户 组: 普通用户
  • 注册时间: 2009-02-22 14:51
文章分类

全部博文(401)

文章存档

2015年(16)

2014年(4)

2013年(12)

2012年(82)

2011年(98)

2010年(112)

2009年(77)

分类: Java

2010-04-07 11:45:25

12.5.2  使用throw关键字抛出异常

throw关键字通常用于方法体中,并且抛出一个异常对象。程序在执行到throw语句时立即终止,它后面的语句都不执行。通过throw抛出异常后,如果想在上一级代码中来捕获并处理异常,则需要在抛出异常的方法中使用throws关键字在方法的声明中指明要抛出的异常;如果要捕捉throw抛出的异常,则必须使用try-catch语句。

throw通常用来抛出用户自定义异常。下面通过实例介绍throw的用法。

例12.7  在项目中创建类MyException继承Exception,创建自定义异常类。(实例位置:光盘\TM\sl\12\7)

public class MyException extends Exception {   //创建自定义异常类
String message;       //定义String类型变量
public MyException(String ErrorMessagr) {  //父类方法
message = ErrorMessagr;
}
public String getMessage(){     //覆盖getMessage()方法
return message;
}
}
在项目中创建Captor类,该类中的quotient()方法传递两个int型参数,如果其中的一个参数为负数则会抛出MyException异常,最后在main()方法中捕捉异常。

例12.8  使用throw关键字捕捉异常。(实例位置:光盘\TM\sl\12\8)

public class Captor {         //创建类
static int quotient(int x,int y) throws MyException{  //定义方法抛出异常
if(y < 0){         //判断参数是否小于0
throw new MyException("除数不能是负数"); //异常信息
}
return x/y;         //返回值
}
public static void main(String args[]){     //主方法
try{          //try语句包含可能发生异常的语句
int result = quotient(3,-1);     //调用方法quotient()
}
catch (MyException e) {      //处理自定义异常
System.out.println(e.getMessage());   //输出异常信息
}
catch (ArithmeticException e) {     //处理ArithmeticException异常
System.out.println("除数不能为0");   //输出提示信息
}
catch (Exception e) {       //处理其他异常
System.out.println("程序发生了其他的异常"); //输出提示信息
}
}
}
运行结果如图12.6所示。
 
图12.6  实例12.8的运行结果
在上面的实例中使用了多个catch语句来捕捉异常。如果调用quotient(3,-1),将发生MyException异常,程序调转到catch (MyException e)代码块中执行;如果调用quotient(5,0)方法会发生ArithmeticException异常,程序调转到catch (ArithmeticException e)代码块中执行;如还有其他异常发生,将使用catch (Exception e)捕捉异常。由于Exception是所有异常类的父类,如果将catch (Exception e)代码块放在其他两个代码块的前面,后面的代码块将永远得不到执行,就没有什么意义了,所以catch语句的顺序不可掉换。
阅读(4666) | 评论(0) | 转发(0) |
给主人留下些什么吧!~~